"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _multipleChoiceList = _interopRequireWildcard(require("@data-driven-forms/common/multiple-choice-list"));

var _FormCheckbox = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormCheckbox.js"));

var _Header = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Header/Header.js"));

var _FormField = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormField.js"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _clsx2 = _interopRequireDefault(require("clsx"));

var _helpers = require("../helpers/helpers");

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  header: {
    marginBottom: '0 !important',
    display: 'inline',
    fontSize: '0.92857143em !important'
  },
  error: {
    color: '#9f3a38 !important'
  },
  items: {
    marginBottom: '1em'
  },
  required: {
    '&:after': {
      content: '"*"',
      margin: '-0.2em 0 0 0.2em',
      color: '#db2828'
    }
  }
});
var CheckboxContext = (0, _react.createContext)({});

var FinalCheckbox = function FinalCheckbox(_ref) {
  var label = _ref.label,
      _isDisabled = _ref.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["label", "isDisabled"]);

  var _useContext = (0, _react.useContext)(CheckboxContext),
      _useContext$props = _useContext.props,
      isRequired = _useContext$props.isRequired,
      isReadOnly = _useContext$props.isReadOnly,
      helperText = _useContext$props.helperText,
      validate = _useContext$props.validate,
      isDisabled = _useContext$props.isDisabled,
      meta = _useContext$props.meta,
      props = (0, _objectWithoutProperties2["default"])(_useContext$props, ["isRequired", "isReadOnly", "helperText", "validate", "isDisabled", "meta"]);

  return /*#__PURE__*/_react["default"].createElement(_FormCheckbox["default"], (0, _extends2["default"])({}, rest, props, {
    disabled: isDisabled,
    label: label
  }));
};

FinalCheckbox.propTypes = {
  isDisabled: _propTypes["default"].bool,
  label: _propTypes["default"].node
};

var Wrapper = function Wrapper(_ref2) {
  var _clsx;

  var label = _ref2.label,
      isRequired = _ref2.isRequired,
      children = _ref2.children,
      meta = _ref2.meta,
      validateOnMount = _ref2.validateOnMount,
      helperText = _ref2.helperText;
  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  var classes = useStyles();

  var _useContext2 = (0, _react.useContext)(CheckboxContext),
      FormFieldGridProps = _useContext2.FormFieldGridProps,
      FormFieldProps = _useContext2.FormFieldProps,
      HelperTextProps = _useContext2.HelperTextProps,
      _useContext2$OptionsL = _useContext2.OptionsListProps,
      optionsClassName = _useContext2$OptionsL.className,
      OptionsListProps = (0, _objectWithoutProperties2["default"])(_useContext2$OptionsL, ["className"]),
      _useContext2$HeaderPr = _useContext2.HeaderProps,
      headerClassname = _useContext2$HeaderPr.className,
      HeaderProps = (0, _objectWithoutProperties2["default"])(_useContext2$HeaderPr, ["className"]);

  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormField["default"], (0, _extends2["default"])({}, FormFieldProps, invalid && {
    error: {
      content: meta.error || meta.submitError,
      pointing: 'left'
    }
  }, {
    label: /*#__PURE__*/_react["default"].createElement(_Header["default"], (0, _extends2["default"])({}, HeaderProps, {
      className: (0, _clsx2["default"])(headerClassname, (_clsx = {}, (0, _defineProperty2["default"])(_clsx, classes.header, true), (0, _defineProperty2["default"])(_clsx, classes.error, invalid), (0, _defineProperty2["default"])(_clsx, classes.required, isRequired), _clsx))
    }), label)
  })), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, OptionsListProps, {
    className: (0, _clsx2["default"])(classes.items, optionsClassName)
  }), children));
};

Wrapper.propTypes = _objectSpread({}, _multipleChoiceList.wrapperProps);

var MultipleChoiceList = function MultipleChoiceList(_ref3) {
  var FormFieldGridProps = _ref3.FormFieldGridProps,
      FormFieldProps = _ref3.FormFieldProps,
      HeaderProps = _ref3.HeaderProps,
      OptionsListProps = _ref3.OptionsListProps,
      HelperTextProps = _ref3.HelperTextProps,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["FormFieldGridProps", "FormFieldProps", "HeaderProps", "OptionsListProps", "HelperTextProps"]);
  return /*#__PURE__*/_react["default"].createElement(CheckboxContext.Provider, {
    value: {
      props: props,
      FormFieldGridProps: FormFieldGridProps,
      FormFieldProps: FormFieldProps,
      HeaderProps: HeaderProps,
      OptionsListProps: OptionsListProps,
      HelperTextProps: HelperTextProps
    }
  }, /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({}, props, {
    Wrapper: Wrapper,
    Checkbox: FinalCheckbox
  })));
};

MultipleChoiceList.propTypes = {
  FormFieldGridProps: _propTypes["default"].object,
  FormFieldProps: _propTypes["default"].object,
  HeaderProps: _propTypes["default"].object,
  OptionsListProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object
};
MultipleChoiceList.defaultProps = {
  FormFieldGridProps: {},
  FormFieldProps: {},
  HeaderProps: {},
  OptionsListProps: {},
  HelperTextProps: {}
};
var _default = MultipleChoiceList;
exports["default"] = _default;