"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _dualListSelect = _interopRequireDefault(require("@data-driven-forms/common/dual-list-select"));

var _Button = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Button/Button.js"));

var _Grid = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Grid/Grid.js"));

var _GridColumn = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Grid/GridColumn.js"));

var _Input = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Input/Input.js"));

var _Segment = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Segment/Segment.js"));

var _Header = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Header/Header.js"));

var _formField = _interopRequireDefault(require("../form-field"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _clsx2 = _interopRequireDefault(require("clsx"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid"));

var _helpers = require("../helpers/helpers");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useListStyles = (0, _reactJssCjs.createUseStyles)({
  root: {
    padding: '.25em'
  },
  selected: {
    color: 'white',
    background: '#2185d0'
  }
});

var List = function List(_ref) {
  var value = _ref.value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      _ref$OptionProps = _ref.OptionProps,
      className = _ref$OptionProps.className,
      selectedClassName = _ref$OptionProps.selectedClassName,
      OptionProps = (0, _objectWithoutProperties2["default"])(_ref$OptionProps, ["className", "selectedClassName"]),
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["value", "optionClick", "noOptionsTitle", "filterValue", "filterValueText", "selectedValues", "OptionProps"]);
  var classes = useListStyles();
  return /*#__PURE__*/_react["default"].createElement(_Segment["default"], rest, value.length < 1 && /*#__PURE__*/_react["default"].createElement("div", null, filterValue ? filterValueText : noOptionsTitle), value.length > 0 && value.map(function (_ref2) {
    var _clsx;

    var value = _ref2.value,
        label = _ref2.label;
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.root, className, (_clsx = {}, (0, _defineProperty2["default"])(_clsx, classes.selected, selectedValues.includes(value)), (0, _defineProperty2["default"])(_clsx, selectedClassName, selectedValues.includes(value)), _clsx))
    }, OptionProps, {
      onClick: function onClick(e) {
        return optionClick(e, value);
      },
      key: value,
      value: value
    }), label);
  }));
};

List.propTypes = {
  value: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].string.isRequired,
    label: _propTypes["default"].string.isRequired
  })),
  optionClick: _propTypes["default"].func.isRequired,
  noOptionsTitle: _propTypes["default"].node,
  filterValue: _propTypes["default"].string,
  filterValueText: _propTypes["default"].node,
  selectedValues: _propTypes["default"].array,
  OptionProps: _propTypes["default"].shape({
    className: _propTypes["default"].string,
    selectedClassName: _propTypes["default"].string
  })
};
List.defaultProps = {
  value: [],
  OptionProps: {}
};

var Toolbar = function Toolbar(_ref3) {
  var sortTitle = _ref3.sortTitle,
      onFilter = _ref3.onFilter,
      onSort = _ref3.onSort,
      sortDirection = _ref3.sortDirection,
      value = _ref3.value,
      placeholder = _ref3.placeholder,
      id = _ref3.id,
      sortUpIcon = _ref3.sortUpIcon,
      sortDownIcon = _ref3.sortDownIcon,
      rest = (0, _objectWithoutProperties2["default"])(_ref3, ["sortTitle", "onFilter", "onSort", "sortDirection", "value", "placeholder", "id", "sortUpIcon", "sortDownIcon"]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    id: id
  }, /*#__PURE__*/_react["default"].createElement(_Input["default"], (0, _extends2["default"])({
    name: "filterOptions",
    id: "filterOptions",
    type: "search",
    icon: "search",
    iconPosition: "left",
    "aria-label": placeholder,
    onChange: function onChange(_ref4) {
      var value = _ref4.target.value;
      return onFilter(value);
    },
    placeholder: placeholder,
    action: /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      type: "button",
      onClick: onSort,
      title: sortTitle,
      icon: sortDirection ? sortUpIcon : sortDownIcon
    })
  }, rest)));
};

Toolbar.propTypes = {
  sortTitle: _propTypes["default"].node,
  onFilter: _propTypes["default"].func.isRequired,
  onSort: _propTypes["default"].func.isRequired,
  sortDirection: _propTypes["default"].bool,
  value: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  id: _propTypes["default"].string,
  sortUpIcon: _propTypes["default"].string,
  sortDownIcon: _propTypes["default"].string
};
Toolbar.defaultProps = {
  sortUpIcon: 'sort amount up',
  sortDownIcon: 'sort amount down'
};
var useDualListStyles = (0, _reactJssCjs.createUseStyles)({
  dualListButtons: {
    display: 'flex !important',
    alignItems: 'flex-start',
    justifyContent: 'center'
  },
  transferButton: {
    display: 'block !important',
    margin: 'auto !important'
  },
  formField: {
    '&>label': {
      display: 'inline-block !important'
    }
  },
  '@media screen and (max-width: 767px)': {
    transferButton: {
      transform: 'rotate(90deg)'
    }
  }
});

var DualList = function DualList(_ref5) {
  var meta = _ref5.meta,
      input = _ref5.input,
      allToRight = _ref5.allToRight,
      allToLeft = _ref5.allToLeft,
      leftTitle = _ref5.leftTitle,
      moveAllLeftTitle = _ref5.moveAllLeftTitle,
      moveAllRightTitle = _ref5.moveAllRightTitle,
      moveRightTitle = _ref5.moveRightTitle,
      moveLeftTitle = _ref5.moveLeftTitle,
      rightTitle = _ref5.rightTitle,
      label = _ref5.label,
      isRequired = _ref5.isRequired,
      helperText = _ref5.helperText,
      noValueTitle = _ref5.noValueTitle,
      noOptionsTitle = _ref5.noOptionsTitle,
      filterOptionsTitle = _ref5.filterOptionsTitle,
      filterValueTitle = _ref5.filterValueTitle,
      filterValueText = _ref5.filterValueText,
      filterOptionsText = _ref5.filterOptionsText,
      state = _ref5.state,
      id = _ref5.id,
      sortOptions = _ref5.sortOptions,
      filterOptions = _ref5.filterOptions,
      handleOptionsClick = _ref5.handleOptionsClick,
      leftValues = _ref5.leftValues,
      handleMoveRight = _ref5.handleMoveRight,
      handleMoveLeft = _ref5.handleMoveLeft,
      handleClearLeftValues = _ref5.handleClearLeftValues,
      handleClearRightValues = _ref5.handleClearRightValues,
      sortValues = _ref5.sortValues,
      filterValues = _ref5.filterValues,
      rightValues = _ref5.rightValues,
      handleValuesClick = _ref5.handleValuesClick,
      validateOnMount = _ref5.validateOnMount,
      OptionsListProps = _ref5.OptionsListProps,
      OptionProps = _ref5.OptionProps,
      _ref5$LabelProps = _ref5.LabelProps,
      labelClassName = _ref5$LabelProps.className,
      labelError = _ref5$LabelProps.error,
      LabelProps = (0, _objectWithoutProperties2["default"])(_ref5$LabelProps, ["className", "error"]),
      ToolbarProps = _ref5.ToolbarProps,
      _ref5$ButtonGridProps = _ref5.ButtonGridProps,
      buttonGridClassName = _ref5$ButtonGridProps.className,
      ButtonGridProps = (0, _objectWithoutProperties2["default"])(_ref5$ButtonGridProps, ["className"]),
      RightButtonProps = _ref5.RightButtonProps,
      DoubleRightButtonProps = _ref5.DoubleRightButtonProps,
      LeftButtonProps = _ref5.LeftButtonProps,
      DoubleLeftButtonProps = _ref5.DoubleLeftButtonProps,
      OptionsHeaderProps = _ref5.OptionsHeaderProps,
      ValuesHeaderProps = _ref5.ValuesHeaderProps,
      HelperTextProps = _ref5.HelperTextProps,
      FormFieldGridProps = _ref5.FormFieldGridProps;
  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  var classes = useDualListStyles();
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_formField["default"], (0, _extends2["default"])({
    label: label,
    required: isRequired,
    error: invalid && _objectSpread({
      content: meta.error || meta.submitError,
      pointing: 'left'
    }, labelError),
    id: id || input.name,
    control: function control(props) {
      return null;
    }
  }, LabelProps, {
    className: (0, _clsx2["default"])(classes.formField, labelClassName)
  })), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
    key: "0"
  }, /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    mobile: 16,
    tablet: 7,
    computer: 7
  }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], null, /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(_Header["default"], (0, _extends2["default"])({
    sub: true
  }, OptionsHeaderProps), leftTitle)), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(Toolbar, (0, _extends2["default"])({
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    onFilter: filterOptions,
    value: state.filterOptions,
    placeholder: filterOptionsTitle,
    id: "".concat(input.name, "-options-toolbar")
  }, ToolbarProps))), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(List, (0, _extends2["default"])({}, OptionsListProps, {
    OptionProps: OptionProps,
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues
  }))))), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], (0, _extends2["default"])({
    className: (0, _clsx2["default"])(classes.dualListButtons, buttonGridClassName)
  }, ButtonGridProps, {
    mobile: 16,
    tablet: 2,
    computer: 2
  }), /*#__PURE__*/_react["default"].createElement(_Grid["default"], null, /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    className: classes.transferButton,
    icon: "angle right"
  }, RightButtonProps, {
    type: "button",
    disabled: leftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle
  }))), allToRight && /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    className: classes.transferButton,
    icon: "angle double right"
  }, DoubleRightButtonProps, {
    type: "button",
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle
  }))), allToLeft && /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    className: classes.transferButton,
    icon: "angle double left"
  }, LeftButtonProps, {
    type: "button",
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle
  }))), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    className: classes.transferButton,
    icon: "angle left"
  }, DoubleLeftButtonProps, {
    type: "button",
    disabled: rightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle
  }))))), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    mobile: 16,
    tablet: 7,
    computer: 7
  }, /*#__PURE__*/_react["default"].createElement(_Grid["default"], null, /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(_Header["default"], (0, _extends2["default"])({
    sub: true
  }, ValuesHeaderProps), rightTitle)), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(Toolbar, (0, _extends2["default"])({
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    onFilter: filterValues,
    value: state.filterValue,
    placeholder: filterValueTitle,
    id: "".concat(input.name, "-value-toolbar")
  }, ToolbarProps))), /*#__PURE__*/_react["default"].createElement(_GridColumn["default"], {
    tablet: 16
  }, /*#__PURE__*/_react["default"].createElement(List, (0, _extends2["default"])({}, OptionsListProps, {
    OptionProps: OptionProps,
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues
  })))))));
};

DualList.propTypes = {
  leftTitle: _propTypes["default"].node,
  rightTitle: _propTypes["default"].node,
  moveLeftTitle: _propTypes["default"].node,
  moveRightTitle: _propTypes["default"].node,
  allToLeft: _propTypes["default"].bool,
  allToRight: _propTypes["default"].bool,
  moveAllLeftTitle: _propTypes["default"].node,
  moveAllRightTitle: _propTypes["default"].node,
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  noValueTitle: _propTypes["default"].node,
  noOptionsTitle: _propTypes["default"].node,
  filterOptionsTitle: _propTypes["default"].node,
  filterValueTitle: _propTypes["default"].node,
  filterValueText: _propTypes["default"].node,
  filterOptionsText: _propTypes["default"].node,
  id: _propTypes["default"].string,
  input: _propTypes["default"].shape({
    name: _propTypes["default"].string.isRequired
  }),
  meta: _propTypes["default"].any,
  state: _propTypes["default"].object,
  sortOptions: _propTypes["default"].func,
  filterOptions: _propTypes["default"].func,
  handleOptionsClick: _propTypes["default"].func,
  leftValues: _propTypes["default"].array,
  handleMoveRight: _propTypes["default"].func,
  handleMoveLeft: _propTypes["default"].func,
  handleClearLeftValues: _propTypes["default"].func,
  handleClearRightValues: _propTypes["default"].func,
  sortValues: _propTypes["default"].func,
  filterValues: _propTypes["default"].func,
  rightValues: _propTypes["default"].array,
  handleValuesClick: _propTypes["default"].func,
  validateOnMount: _propTypes["default"].bool,

  /** Sub components customization API */
  OptionsListProps: _propTypes["default"].object,
  OptionProps: _propTypes["default"].object,
  LabelProps: _propTypes["default"].shape({
    error: _propTypes["default"].object,
    className: _propTypes["default"].string
  }),
  ToolbarProps: _propTypes["default"].object,
  ButtonGridProps: _propTypes["default"].shape({
    className: _propTypes["default"].string
  }),
  RightButtonProps: _propTypes["default"].object,
  DoubleRightButtonProps: _propTypes["default"].object,
  LeftButtonProps: _propTypes["default"].object,
  DoubleLeftButtonProps: _propTypes["default"].object,
  OptionsHeaderProps: _propTypes["default"].object,
  ValuesHeaderProps: _propTypes["default"].object,
  HelperTextProps: _propTypes["default"].object,
  FormFieldGridProps: _propTypes["default"].object
};
DualList.defaultProps = {
  leftTitle: 'Options',
  rightTitle: 'Selected',
  moveLeftTitle: 'Move selected to left',
  moveRightTitle: 'Move selected to right',
  moveAllRightTitle: 'Move all to right',
  moveAllLeftTitle: 'Move all to left',
  noOptionsTitle: 'No available options',
  noValueTitle: 'No selected',
  filterOptionsTitle: 'Filter options',
  filterValueTitle: 'Filter selected value',
  filterOptionsText: 'Remove your filter to see all options',
  filterValueText: 'Remove your filter to see all selected',
  options: [],
  allToLeft: true,
  allToRight: true,
  OptionsListProps: {},
  OptionProps: {},
  LabelProps: {},
  ToolbarProps: {},
  ButtonGridProps: {},
  RightButtonProps: {},
  DoubleRightButtonProps: {},
  LeftButtonProps: {},
  DoubleLeftButtonProps: {},
  OptionsHeaderProps: {},
  ValuesHeaderProps: {},
  HelperTextProps: {},
  FormFieldGridProps: {}
};

var DualListSelectWrapper = function DualListSelectWrapper(props) {
  return /*#__PURE__*/_react["default"].createElement(_dualListSelect["default"], (0, _extends2["default"])({}, props, {
    DualListSelect: DualList
  }));
};

var _default = DualListSelectWrapper;
exports["default"] = _default;