"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Switch = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormCheckbox = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/collections/Form/FormCheckbox.js"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _clsx2 = _interopRequireDefault(require("clsx"));

var _helpers = require("../helpers/helpers");

var _formField = _interopRequireDefault(require("../form-field/form-field"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  root: {
    '&>.field': {
      display: 'inline-block'
    }
  },
  errorLabel: {
    '&:after': {
      content: '"*"',
      color: '#db2828'
    }
  }
});

var Switch = function Switch(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  })),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      onText = _useFieldApi.onText,
      offText = _useFieldApi.offText,
      className = _useFieldApi.className,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      HelpertextProps = _useFieldApi.HelpertextProps,
      type = _useFieldApi.type,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "onText", "offText", "className", "FormFieldGridProps", "HelpertextProps", "type"]);

  var invalid = (0, _helpers.validationError)(meta, validateOnMount);
  var classes = useStyles();
  var controlLabel = input.checked ? onText : offText;
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    helperText: (0, _helpers.validationWarning)(meta, validateOnMount) || helperText,
    HelpertextProps: HelpertextProps
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_formField["default"], (0, _extends2["default"])({
    required: isRequired,
    className: (0, _clsx2["default"])(classes.root, className),
    error: invalid && {
      content: meta.error || meta.submitError,
      pointing: 'left'
    }
  }, rest, {
    label: /*#__PURE__*/_react["default"].createElement(_FormCheckbox["default"], (0, _extends2["default"])({
      className: (0, _clsx2["default"])((0, _defineProperty2["default"])({}, classes.errorLabel, isRequired)),
      toggle: true,
      label: controlLabel || label
    }, input, {
      disabled: isDisabled,
      onChange: function onChange(event, data) {
        return input.onChange({
          target: data
        });
      }
    }))
  })));
};

exports.Switch = Switch;
Switch.propTypes = {
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  onText: _propTypes["default"].node,
  offText: _propTypes["default"].node,
  description: _propTypes["default"].node,

  /** Sub components customization API */
  FormFieldGridProps: _propTypes["default"].object,
  HelpertextProps: _propTypes["default"].object
};
Switch.defaultProps = {
  FormFieldGridProps: {},
  HelpertextProps: {}
};
var _default = Switch;
exports["default"] = _default;