"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Tab = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/modules/Tab/Tab.js"));

var _TabPane = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/modules/Tab/TabPane.js"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var TabContent = function TabContent(_ref) {
  var name = _ref.name,
      fields = _ref.fields,
      formOptions = _ref.formOptions;
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, {
    key: name
  }, formOptions.renderForm(fields, formOptions));
};

TabContent.propTypes = {
  name: _propTypes["default"].string.isRequired,
  fields: _propTypes["default"].array.isRequired,
  formOptions: _propTypes["default"].shape({
    renderForm: _propTypes["default"].func.isRequired
  }).isRequired
};

var FormTabs = function FormTabs(_ref2) {
  var fields = _ref2.fields,
      TabProps = _ref2.TabProps,
      TabPaneProps = _ref2.TabPaneProps;
  var formOptions = (0, _useFormApi["default"])();
  var panes = fields.map(function (field, index) {
    return {
      menuItem: field.title,
      pane: /*#__PURE__*/_react["default"].createElement(_TabPane["default"], (0, _extends2["default"])({}, TabPaneProps, {
        key: index
      }), /*#__PURE__*/_react["default"].createElement(TabContent, (0, _extends2["default"])({}, field, {
        formOptions: formOptions
      })))
    };
  });
  return /*#__PURE__*/_react["default"].createElement(_Tab["default"], (0, _extends2["default"])({
    renderActiveOnly: false
  }, TabProps, {
    panes: panes
  }));
};

FormTabs.propTypes = {
  fields: _propTypes["default"].array.isRequired,
  TabProps: _propTypes["default"].object,
  TabPaneProps: _propTypes["default"].object
};
FormTabs.defaultProps = {
  TabProps: {},
  TabPaneProps: {}
};
var _default = FormTabs;
exports["default"] = _default;