"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var _Button = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Button/Button.js"));

var useStyles = (0, _reactJssCjs.createUseStyles)({
  root: {
    display: 'flex',
    justifyContent: 'space-between'
  }
});

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      valid = _ref.valid,
      handleNext = _ref.handleNext,
      nextLabel = _ref.nextLabel,
      getState = _ref.getState,
      handleSubmit = _ref.handleSubmit,
      submitLabel = _ref.submitLabel,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;
  var nextResult = nextStep ? (0, _selectNext["default"])(nextStep, getState) : nextStep;
  var progressNext = nextResult !== conditionalSubmitFlag && nextStep;
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    icon: progressNext ? 'right arrow' : undefined,
    color: "blue",
    labelPosition: progressNext ? 'right' : undefined,
    content: progressNext ? nextLabel : submitLabel,
    disabled: !valid || getState().validating || getState().submitting,
    onClick: function onClick() {
      return progressNext ? handleNext(nextResult) : handleSubmit();
    },
    type: "button"
  });
};

NextButton.propTypes = {
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].object]),
  handleSubmit: _propTypes["default"].func.isRequired,
  submitLabel: _propTypes["default"].node.isRequired,
  valid: _propTypes["default"].bool,
  handleNext: _propTypes["default"].func.isRequired,
  nextLabel: _propTypes["default"].node.isRequired,
  getState: _propTypes["default"].func.isRequired,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired
};

var WizardStepButtons = function WizardStepButtons(_ref2) {
  var conditionalSubmitFlag = _ref2.conditionalSubmitFlag,
      Buttons = _ref2.buttons,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["conditionalSubmitFlag", "buttons"]);
  var classes = useStyles();

  if (Buttons) {
    return /*#__PURE__*/_react["default"].createElement(Buttons, props);
  }

  var disableBack = props.disableBack,
      handlePrev = props.handlePrev,
      nextStep = props.nextStep,
      handleNext = props.handleNext,
      _props$buttonLabels = props.buttonLabels,
      cancel = _props$buttonLabels.cancel,
      submit = _props$buttonLabels.submit,
      back = _props$buttonLabels.back,
      next = _props$buttonLabels.next,
      formOptions = props.formOptions;
  return /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      values: true,
      valid: true,
      validating: true,
      submitting: true
    }
  }, function () {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: classes.root
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      type: "button",
      onClick: formOptions.onCancel
    }, cancel), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      icon: "left arrow",
      labelPosition: "left",
      content: back,
      type: "button",
      disabled: disableBack,
      onClick: handlePrev
    }), /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
      conditionalSubmitFlag: conditionalSubmitFlag,
      handleNext: handleNext,
      nextStep: nextStep,
      nextLabel: next,
      submitLabel: submit
    }))));
  });
};

WizardStepButtons.propTypes = {
  disableBack: _propTypes["default"].bool,
  handlePrev: _propTypes["default"].func.isRequired,
  handleNext: _propTypes["default"].func.isRequired,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired,
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].shape({
    when: _propTypes["default"].string.isRequired,
    stepMapper: _propTypes["default"].object.isRequired
  }), _propTypes["default"].func]),
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node.isRequired,
    cancel: _propTypes["default"].node.isRequired,
    back: _propTypes["default"].node.isRequired,
    next: _propTypes["default"].node.isRequired
  }).isRequired,
  buttons: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  formOptions: _propTypes["default"].shape({
    getState: _propTypes["default"].func.isRequired,
    onCancel: _propTypes["default"].func.isRequired
  })
};
var _default = WizardStepButtons;
exports["default"] = _default;