"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));

var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard/wizard"));

var _wizardNav = _interopRequireDefault(require("./wizard-nav"));

var _stepButtons = _interopRequireDefault(require("./step-buttons"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var WizardInternal = function WizardInternal(_ref) {
  var buttonLabels = _ref.buttonLabels,
      stepsInfo = _ref.stepsInfo,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;

  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
      formOptions = _useContext.formOptions,
      currentStep = _useContext.currentStep,
      handlePrev = _useContext.handlePrev,
      onKeyDown = _useContext.onKeyDown,
      handleNext = _useContext.handleNext,
      activeStepIndex = _useContext.activeStepIndex,
      prevSteps = _useContext.prevSteps;

  var buttonLabelsFinal = _objectSpread({
    next: 'Continue',
    submit: 'Submit',
    cancel: 'Cancel',
    back: 'Back'
  }, buttonLabels);

  return /*#__PURE__*/_react["default"].createElement("div", {
    onKeyDown: onKeyDown
  }, stepsInfo && /*#__PURE__*/_react["default"].createElement(_wizardNav["default"], {
    stepsInfo: stepsInfo,
    activeStepIndex: activeStepIndex
  }), /*#__PURE__*/_react["default"].createElement("div", null, currentStep.fields.map(function (item) {
    return formOptions.renderForm([item], formOptions);
  }), /*#__PURE__*/_react["default"].createElement(_stepButtons["default"], (0, _extends2["default"])({}, currentStep, {
    conditionalSubmitFlag: conditionalSubmitFlag,
    formOptions: formOptions,
    buttonLabels: buttonLabelsFinal,
    handleNext: handleNext,
    handlePrev: handlePrev,
    disableBack: prevSteps.length === 0
  }))));
};

WizardInternal.propTypes = {
  buttonLabels: _propTypes["default"].object,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired,
  stepsInfo: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    title: _propTypes["default"].node,
    label: _propTypes["default"].node,
    StepLabelProps: _propTypes["default"].object,
    StepProps: _propTypes["default"].object
  }))
};

var SuirWizard = function SuirWizard(props) {
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal
  }, props));
};

var _default = SuirWizard;
exports["default"] = _default;